#python

#VOLULIGHT

# By Philip Lawson (phil@uberdesigns.co.uk)

#A script that will create a point light on every vertex of the currently 
#selected layer and enable volumetrics.

#Any lines with comments can be edited by the user to adjust the look of 
#the lights.

import lx

#----------------Variables----------------#
lx.eval("select.typeFrom polygon;edge;vertex;item;pivot;center;ptag true")
currentLayer = lx.eval("query layerservice layer.index ? Selected")
numOfVerts = lx.eval("query layerservice vert.N ? %s" % currentLayer)
verts=[]
i=0
selectedMeshIDs = []
currentLight = ""

#-----------------------------------------#
#-----------------methods-----------------#
#-----------------------------------------#

def makeLight():
  selectedMeshIDs = lx.evalN("query sceneservice selection ? mesh")
  lx.eval("select.drop item")
  lx.eval("item.create pointLight") #Options ( pointLight | spotLight )
  currentLight = lx.eval("query sceneservice selection ? light")
  lx.eval("item.channel pointLight$volumetrics true")
  lx.eval("query sceneservice selection ? light")
  lx.eval("item.channel pointLight$vsamples 64") #Sets the number of samples
  lx.eval("item.channel pointLight$vrad 0.2") #Sets the size of the point light || Comment this out if using a spotLight.
  lx.eval("tool.set TransformMove on")
  lx.eval("select.drop channel")
  lx.eval("transform.channel pos.X %s" % verts[0])
  lx.eval("transform.channel pos.Y %s" % verts[1])
  lx.eval("transform.channel pos.Z %s" % verts[2])
  lx.eval("tool.set TransformMove off 0")
  
  children = lx.eval("query sceneservice light.children ? %s" % currentLight)
  lx.eval("select.subItem %s set textureLayer;render;environment;light;camera;mediaClip;txtrLocator" % children)
  lx.eval("item.channel lightMaterial$scatteringColor {0.7299 0.145 0.0}") #Changes the scattering of the light
  lx.eval("item.channel lightMaterial$density 0.2") #Changes the density (0.2 = 20%).
  lx.eval("item.channel lightMaterial$attenuate 0.8") #Changes the attenuate (0.8 = 80%).
  lx.eval("item.channel lightMaterial$shift 0.8") #Changes the shift (0.8 = 80%).

#--------------------RUN------------------#
monitor = lx.Monitor()
monitor.init(numOfVerts)

if (lx.eval("query sceneservice selection ? mesh") != "none"):
  while (i < numOfVerts):
    verts = lx.eval("query layerservice vert.wpos ? %s" % i)
    lx.out(verts)
    makeLight()
    i=i+1
    monitor.step(1)
else:
    # Setup the dialog
    lx.eval("dialog.setup info")
    lx.eval("dialog.title \"Warning\"")
    lx.eval("dialog.msg \"You must select 1 mesh item.\"")

    #Open the dialog Window
    lx.eval("dialog.open")
    lx.out("Script Exit")